package org.processmining.datapetrinets;

import org.processmining.models.graphbased.directed.petrinet.Petrinet;
import org.processmining.models.graphbased.directed.petrinetwithdata.newImpl.PetriNetWithData;
import org.processmining.models.graphbased.directed.petrinetwithdata.newImpl.PetriNetWithDataFactory;
import org.processmining.models.semantics.petrinet.Marking;

public interface DataPetriNetsWithMarkings extends DataPetriNet {

	public class Factory {

		public static DataPetriNetsWithMarkings create(String label) {
			return new PetriNetWithData(label);
		}

		public static DataPetriNetsWithMarkings fromPetrinet(Petrinet net, Marking initialMarking,
				Marking[] finalMarking) {
			PetriNetWithDataFactory factory = new PetriNetWithDataFactory(net, net.getLabel());
			PetriNetWithData dpn = factory.getRetValue();
			dpn.setInitialMarking(factory.convertMarking(initialMarking));
			Marking[] newFinalMarkings = new Marking[finalMarking.length];
			for (int i = 0; i < finalMarking.length; i++) {
				Marking marking = finalMarking[i];
				newFinalMarkings[i] = factory.convertMarking(marking);
			}
			dpn.setFinalMarkings(newFinalMarkings);
			return dpn;
		}
		
	}

	void setInitialMarking(Marking marking);

	Marking getInitialMarking();

	void setFinalMarkings(Marking[] markings);

	Marking[] getFinalMarkings();

}
