package org.processmining.datapetrinets.datadiscovery;

import java.util.Map;

import org.processmining.datapetrinets.expression.GuardExpression;
import org.processmining.models.graphbased.directed.petrinet.Petrinet;
import org.processmining.models.graphbased.directed.petrinet.PetrinetGraph;
import org.processmining.models.graphbased.directed.petrinet.elements.Place;
import org.processmining.models.graphbased.directed.petrinet.elements.Transition;

public interface DecisionRuleDiscovery {

	public interface DecisionRules {
		Map<Place, DecisionRule> getRules();
	}

	public interface DecisionRule {
		Place getPlace();
		Map<Transition, GuardExpression> getRules();
		String getOverallInfo();
	}

	public DecisionRule discoverRulesForPlace(PetrinetGraph net, Place place) throws RuleDiscoveryException;

	public DecisionRules discoverRules(Petrinet net) throws RuleDiscoveryException;

}