package org.processmining.datapetrinets.visualization.graphviz;

import javax.swing.JComponent;

import org.processmining.contexts.uitopia.annotations.Visualizer;
import org.processmining.datapetrinets.DataPetriNet;
import org.processmining.datapetrinets.utils.MarkingsHelper;
import org.processmining.framework.plugin.PluginContext;
import org.processmining.framework.plugin.annotations.Plugin;
import org.processmining.framework.plugin.annotations.PluginLevel;
import org.processmining.framework.plugin.annotations.PluginVariant;
import org.processmining.models.graphbased.directed.petrinetwithdata.newImpl.PetriNetWithData;
import org.processmining.models.semantics.petrinet.Marking;

@Plugin(name = "Data Petri net (Graphviz)", level = PluginLevel.PeerReviewed, 
returnLabels = { "Data Petri net (Graphviz)" }, returnTypes = { JComponent.class }, userAccessible = true, parameterLabels = { "Matching Instances" })
@Visualizer
public class DPNGraphvizVisualizerPlugin {

	@PluginVariant(requiredParameterLabels = { 0 }) // This is here because the importer still uses the implementation type (backwards compatibility), and we want this visualizer to end up as first
	public JComponent visualise(PluginContext context, PetriNetWithData dpn) {
		return visualise(context, (DataPetriNet) dpn); 
	}

	@PluginVariant(requiredParameterLabels = { 0 })
	public JComponent visualise(PluginContext context, DataPetriNet dpn) {
		Marking initialMarking = MarkingsHelper.getInitialMarkingOrEmpty(context, dpn);
		Marking[] finalMarkings = MarkingsHelper.getFinalMarkingsOrEmpty(context, dpn);		
		return new DPNGraphvizVisualizer(dpn, initialMarking, finalMarkings);
	}

}
