package org.processmining.models.graphbased.directed.petrinetwithdata.newImpl;

import org.jgraph.graph.GraphConstants;
import org.processmining.models.graphbased.AttributeMap;
import org.processmining.models.graphbased.AttributeMap.ArrowType;
import org.processmining.models.graphbased.directed.petrinet.PetrinetEdge;
import org.processmining.models.graphbased.directed.petrinet.PetrinetNode;
import org.processmining.models.graphbased.directed.petrinet.elements.Transition;

public class VariableAccess extends PetrinetEdge<PetrinetNode, PetrinetNode>
{
	private boolean bidirectional=false;
	
	public VariableAccess(DataElement source, Transition target) {
		this((PetrinetNode)source, (PetrinetNode)target);
	}
	
	public VariableAccess(Transition source, DataElement target) {
		this((PetrinetNode)source, (PetrinetNode)target);
	}
	
	private VariableAccess(PetrinetNode source, PetrinetNode target) {
		super(null, source, target, "");
		getAttributeMap().put(AttributeMap.EDGEEND, ArrowType.ARROWTYPE_SIMPLE);
		getAttributeMap().put(AttributeMap.EDGEENDFILLED, false);
		getAttributeMap().put(AttributeMap.DASHPATTERN, new float[] {1F,2F});
		getAttributeMap().put(AttributeMap.STYLE, GraphConstants.STYLE_ORTHOGONAL);
	}

	public void setBidirectional(boolean bidirectional) {
		this.bidirectional = bidirectional;
		if (bidirectional)
		{
			getAttributeMap().put(AttributeMap.EDGESTART, ArrowType.ARROWTYPE_SIMPLE);
			getAttributeMap().put(AttributeMap.EDGESTARTFILLED, false);			
		}
		else
		{
			getAttributeMap().remove(AttributeMap.EDGESTART);
			getAttributeMap().remove(AttributeMap.EDGESTARTFILLED);				
		}
	}

	public boolean isBidirectional() {
		return bidirectional;
	}
	
	
}
